#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

#include "V3.h"

class PPC;

class FrameBuffer : public Fl_Gl_Window {
public:
	unsigned int *pix; // pixel array // 0xAABBGGRR; // red 0xFF0000FF
	int w, h;
	FrameBuffer(int u0, int v0, int _w, int _h);
	void draw();
	void KeyboardHandle();
	int handle(int guievent);
	void LoadTiff(char* fname);
	void SaveAsTiff(char* fname);
	void Set(unsigned int bgr);
	void Set(int u, int v, unsigned int col);
	void SetGuarded(int u, int v, unsigned int col);
	void RasterizeRectangle(int u0, int v0, int l, int h, unsigned int col);
	int ClipRectangle(int& u0, int& v0, int& rw, int& rh);
	void RasterizeCircle(V3 center, float radius, unsigned int color);
	void Rasterize2DSegment(V3 p0, V3 p1, unsigned int color);
};